﻿using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;

namespace Helpers {
   public class EventCommandAction : TriggerAction<DependencyObject> {

      public static readonly DependencyProperty CommandParameterProperty =
          DependencyProperty.Register("CommandParameter", typeof(object), typeof(EventCommandAction));
      public object CommandParameter {
         get { return this.GetValue(CommandParameterProperty); }
         set { this.SetValue(CommandParameterProperty, value); }
      }
      public static readonly DependencyProperty CommandProperty = DependencyProperty.Register(
          "Command", typeof(ICommand), typeof(EventCommandAction));
      public ICommand Command {
         get { return (ICommand)this.GetValue(CommandProperty); }
         set { this.SetValue(CommandProperty, value); }
      }
      protected override void Invoke(object parameter) {
         var cmd = Command;
         if (AssociatedObject == null || cmd == null) {
            MessageBox.Show("EventCommandAction fehlerhaft initialisiert");
            return;
         }
         var param = CommandParameter ?? parameter;
         if (cmd.CanExecute(param)) cmd.Execute(param);
      }
   }
}
