﻿using System;
using System.Windows;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Helpers;
using System.Collections.ObjectModel;
using System.IO;
using System.Diagnostics;

namespace CodebehindSample.ViewModels {
   class MainViewModel : PropertyChangedBase {
      private static MainViewModel _instance;
      public static MainViewModel Instance {
         get { return _instance ?? (_instance = new MainViewModel()); }
      }

      private DelegateCommand openfile;
      public DelegateCommand OpenFile {
         get { return openfile ?? (openfile = new DelegateCommand(() => Process.Start(SelectedFile.FullName))); }
      }

      private DelegateCommand openfolder;
      public DelegateCommand OpenFolder {
         get {
            return openfolder ?? (openfolder = new DelegateCommand(
               () => Process.Start("explorer.exe", string.Format("/select, {0}", SelectedFile.FullName))));
         }
      }

      private DelegateCommand deletefile;
      public DelegateCommand DeleteFile {
         get {
            return deletefile ?? (deletefile = new DelegateCommand(() => {
               SelectedFile.Delete();
               Files.Remove(SelectedFile);
            }));
         }
      }
      private DelegateCommand<DragEventArgs> _ItemsDropCommand;
      public DelegateCommand<DragEventArgs> ItemsDropCommand {
         get {
            return _ItemsDropCommand ?? (_ItemsDropCommand = new DelegateCommand<DragEventArgs>(ItemsDropped));
         }
      }
      private void ItemsDropped(DragEventArgs e) {
         foreach (string file in (string[])e.Data.GetData(DataFormats.FileDrop)) Files.Add(new FileInfo(file));
      }

      private ObservableCollection<FileInfo> files = new ObservableCollection<FileInfo>();
      public ObservableCollection<FileInfo> Files { get { return files; } }


      private FileInfo selectedfile;
      public FileInfo SelectedFile {
         get { return selectedfile; }
         set { SetProperty(value, ref selectedfile); }
      }
   }
}
